static char SccsId[] = "@(#)lr.cc	1.1 12/12/96 Voronoi";
// lr.cc
// Dec 1996
// Copyright 1996 SFBellenot All rights reserved

#include "lr.h"
#include <iostream.h>
#include <iomanip.h>

HalfEdge* LR::LeftBnd ( Point& p )
{
	int i, bucket;
	HalfEdge *he;

	/* Use hash table to get close to desired halfedge */
	bucket = Bucket ( p );
	he = AtBucket(bucket);
	if (he == NULL)
	{
		for (i = 1; 1; i += 1)
		{
			if ((he = AtBucket(bucket - i)) != NULL)
				break;
			if ((he = AtBucket(bucket + i)) != NULL)
				break;
		};
		totalsearch += i;
	}
	ntry += 1;
	/* Now search linear list of halfedges for the corect one */
	if (he == LeftEnd || (he != RightEnd && he->RightOf( p ) ) )
	{
		do
		{
			he = he->RightHalfEdge();
		}
		while (he != RightEnd && he->RightOf ( p ) );
		he = he->LeftHalfEdge();
	}
	else
		do
		{
			he = he->LeftHalfEdge();
		}
		while (he != LeftEnd && !he->RightOf ( p ) );

	/* Update hash table and reference counts */
	if (bucket > 0 && bucket < hashSize - 1)
	{
		if (hash[bucket] != NULL)
			;//hash[bucket]->ELrefcnt -= 1;
		hash[bucket] = he;
		//ELhash[bucket]->ELrefcnt += 1;
	}
	return (he);
}

void LR::Print ( Real y )
{
	HalfEdge* he = LeftEnd->RightHalfEdge();

	for ( ; he != RightEnd; he = he->RightHalfEdge() )
	{
		cout << hex << he << " x = " << he->GetEdge()->X ( y );
		
		if ( he->GetVertex() )
			cout << " vertex " << hex << he->GetVertex() << endl;
		else
			cout << " Null Vertex" << endl;

		he->LRCheck();

		if ( he->RightHalfEdge() == NULL )
			cout << hex << he << " this is it " << endl;
	}
	cout << "LR::Print done" << endl;
}
