#ifndef _POINT_H_
#define _POINT_H_

#pragma ident "@(#)point.h	1.1 12/12/96 Voronoi"
// Dec 1996
// Copyright 1996 SFBellenot All rights reserved

#include <math.h>

#ifndef Real
typedef float Real;
#endif
#ifndef NULL
#define NULL 0
#endif
#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif
inline Real max ( Real a, Real b ) { return ( a < b )? b : a; }
inline Real min ( Real a, Real b ) { return ( a < b )? a : b; }

class Point
{
public:
	Point ( Real X, Real Y ): x(X), y(Y) {}
	Point(): x(0.0), y(0.0) {}
	Real X() { return x; }
	Real Y() { return y; }
	Real X ( Real xnew ) { x = xnew; return x; }
	Real Y ( Real ynew ) { y = ynew; return y; }
	Real Distance ( Point& p )
	{
		Real dx = x-p.x;
		Real dy = y-p.y;
		return sqrt ( dx * dx + dy * dy );
	}
	int LexLess ( Point& old )
	{
		return ( (y < old.y)||((y == old.y) && (x < old.x)) );
	}

private:
	Real x;
	Real y;
};

#endif
