#ifndef _VERTEX_H_
#define _VERTEX_H_

#pragma ident "@(#)vertex.h	1.1 12/12/96 Voronoi"
// Dec 1996
// Copyright 1996 SFBellenot All rights reserved

#include "point.h"

class Vertex: public Point
{
public:
	Vertex ( Real X, Real Y ): Point ( X, Y )
	{
		id = idCounter++;
		refCount = 1;
		siteDistance = 0.0;
	}
	Vertex(): Point()
	{
		id = idCounter++;
		refCount = 1;
		siteDistance = 0.0;
	}
	int Id() { return id; }
	void Ref() { refCount++; }
	void Deref() {
	#if 0
	refCount--; if ( refCount == 0 ) delete this;
	#endif
	}
	Real SiteDistance() { return siteDistance; }
	Real SiteDistance ( Real sd ) { siteDistance = sd; return siteDistance; }

private:
	int id;
	int refCount;
	Real siteDistance;

	static int idCounter;
};

#endif
