static char SccsId[] = "@(#)vmain.cc	1.1 12/12/96 Voronoi";
// vmain.cc
// Dec 1996
// Copyright 1996 SFBellenot All rights reserved

#include "voronoi.h"
#include "tk.h"

static Voronoi* v;
static int draw = TRUE;
static int step;
static int triangle;
extern Pad* padPtr;
extern Tcl_Interp* tclInterp;

int AppOptions ( int argc, char** argv )
{
	int c;
	extern int optind;
	step = 0;
	triangle = 0;

	c = getopt(argc, argv, "st" );
	while ( c != EOF )
	{
		switch ( c )
		{
		case 's':
			step = TRUE;
			break;
		case 't':
			triangle = TRUE;
			break;
		}

		c = getopt(argc, argv, "s" );
	}
	return optind - 1;
}

int AppInit ()
{
	SiteList* sl = new SiteList ( FALSE );
	v = new Voronoi ( sl->XMin(), sl->XMax(), sl->YMin(), sl->YMax(), sl,
		1 + sqrt ( sl->NoSites() ) );
	if ( step )
		Tcl_Eval ( tclInterp, "set run false" );
	if ( triangle )
		v->Triangle();
	return 0;
}

int AppRestart()
{
	SiteList* sl = v->SL();
	sl->Reset();
	delete v;
	v = new Voronoi ( sl->XMin(), sl->XMax(), sl->YMin(), sl->YMax(), sl,
		1 + sqrt ( sl->NoSites() ) );
	if ( !step )
		Tcl_Eval ( tclInterp, "set run true" );
	return 0;
}

int AppLoop ()
{
	int answer = v->Loop();
	if ( draw )
		v->Draw(padPtr);
	return answer;
}

int AppCleanup ()
{
	if ( padPtr )
		v->Draw(padPtr);
	return 0;
}
